<template slot="tab-page-login" class="page-2">
  <div class="d-flex">
    <button class="icon-button text-secondary" @click="$router.push({ hash: '#main' })"
      style="position: absolute; left: 6px; top: 8px; height: 30px;">
      <v-icon name="arrow-left"/>
    </button>

    <div class="d-flex flex-col ph-1 flex-ai-center w-100 ph-2">

      <Error v-if="error" :error.sync="error" round class="mt-2 w-100"/>

      <h2 class="mh-5 mt-1"><i>CREATE ACCOUNT</i></h2>

      <form @submit="onRegister" class="d-flex flex-col w-100">

        <!-- <div class="d-flex flex-row w-100">
          <div class="input-group flex-1 mh-1">
            <input type="text" placeholder="Username" v-model="username">
          </div>
          <div class="input-group flex-1 mh-1">
            <input type="text" placeholder="Username" v-model="username">
          </div>
        </div> -->

        <div class="input-group w-100">
          <v-icon name="id-badge"/>
          <input type="text" placeholder="First name" v-model="first_name">
        </div>

        <div class="input-group w-100">
          <v-icon name="regular/id-badge"/>
          <input type="text" placeholder="Last name" v-model="last_name">
        </div>

        <div class="input-group w-100">
          <v-icon name="at"/>
          <input type="email" placeholder="Email" v-model="email">
        </div>

        <div class="input-group w-100">
          <v-icon name="user"/>
          <input type="text" placeholder="Username" v-model="username">
        </div>

        <div class="input-group w-100">
          <v-icon name="lock"/>
          <input type="password" placeholder="Password" v-model="password">
        </div>

        <div class="input-group w-100" :class="{ error: confirmPwError }">
          <v-icon name="check"/>
          <input type="password" placeholder="Confirm password"
            v-model="confirmPassword">
        </div>

        <a class="mt-3 text-smaller">Forgot your password?</a>

        <AsyncButton class="primary mv-5" :fn="onRegister">
          Create Account
        </AsyncButton>

        <Policy by="Creating an account" class="mb-4"/>

      </form>
    </div>
  </div>
</template>

<script>
import Policy from '@/components/Policy.vue';

export default {
  data: () => ({
    first_name: null,
    last_name: null,
    email: null,
    username: null,
    password: null,
    confirmPassword: null,

    error: null,

    confirmPwError: false,
  }),
  components: {
    Policy,
  },
  watch: {
    password(to) {
      if (this.confirmPassword)
        this.confirmPwError = !(to === this.confirmPassword);
    },
    confirmPassword(to) {
      this.confirmPwError = !(to === this.password);
    },
  },
  methods: {
    empty(val) {
      if (!val)
        return true;
      return (/^\s*$/.test(val));
    },
    async onRegister(e) {
      e.preventDefault();

      this.error = null;

      if (this.empty(this.username) || this.empty(this.first_name) ||
          this.empty(this.last_name) || this.empty(this.email))
        return this.error = 'All fields are required';

      if (this.confirmPwError)
        return this.error = 'Passwords don\'t match';

      try {
        let payload = {
          username: this.username,
          password: this.password,
          email: this.email,
          first_name: this.first_name,
          last_name: this.last_name,
        };

        await this.$store.dispatch('register', payload);
        this.$router.replace({ hash: '#validate' });
      }
      catch(err) {
        err;
        if (err.response)
          this.error = err.response.data.error;
      }
    },
  },
};
</script>

<style scoped>
</style>
